/**************************************************************************
 * JumpDriveMFD V1.0 - FTL travel in a difficult fashion for O2K6
 *     created: July, 6th 2006
 * last update: September, 10th 2006
 * Copyright (c) 2006 Friedrich Kastner-Masilko, M.Sc.
 *
 * JumpDriveMFD class header
 **************************************************************************/
#ifndef __JUMPDRIVEMFD_H
#define __JUMPDRIVEMFD_H

//Each MFD instance has it's own data memory for the JumpDrive mode.
//Even if you switch to another mode, the settings will be saved.
struct JumpDriveMFDData
{
	//target index
	DWORD target;
	//set distance for Z2 calculation
	double distance;
	//set navcomp mode
	int mode;
	//set information about second FLJ's filled cells
	int j2cells;
	//internal flag
	bool setToCurrent;
};

//The JumpDrive MFD mode class.
class JumpDriveMFD: public MFD {
public:
	//Default implementations
	JumpDriveMFD (DWORD w, DWORD h, VESSEL *vessel, UINT mfd);
	~JumpDriveMFD ();
	char *ButtonLabel (int bt);
	int ButtonMenu (const MFDBUTTONMENU **menu) const;
	bool ConsumeKeyBuffered (DWORD key);
	bool ConsumeButton (int bt, int event);
	void Update (HDC hDC);	
	static int MsgProc (UINT msg, UINT mfd, WPARAM wparam, LPARAM lparam);
	//The drive instance the mode is linked to
	JumpDrive *Drive;
	//The data instance the mode is linked to
	JumpDriveMFDData *Data;
private:
	//The vessel the mode is linked to
	VESSEL *vessel;
	//Width and height of the MFD for text positions
	int width;
	int heigth;
	//The sound handle
	int sound;	
};

#endif // !__JUMPDRIVEMFD_H